;scale2x filter
;16bpp output
;----------------------------------------------------------
;Copyright (C) 2004 Nick o'DIMM ( nick_o_dimm[at]pochtamt[dot]ru )
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either
;version 2 of the License, or (at your option) any later
;version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


%include "nasmhead.inc"

section .data align=64

	extern MD_Screen


section .bss align=64

	LineBuf:	resb 640 * 2
	LineBuf2:	resb 640 * 2
	H:		resb 2
	D:		resb 2
	E:		resb 2
	F:		resb 2
	B:		resb 2

section .text align=64

	ALIGN64
	
	;************************************************************************
	; void Blit_Scale2x(unsigned char *Dest, int pitch, int x, int y, int offset)
	DECL Blit_Scale2x

		push ebx
		push ecx
		push edx
		push edi
		push esi

		mov ecx, [esp + 32]				; ecx = Nombre de pix par ligne
		mov ebx, [esp + 28]				; ebx = pitch de la surface Dest
		lea ecx, [ecx * 4]				; ecx = Nb bytes par ligne Dest
		lea esi, [MD_Screen + 8 * 2]	; esi = Source
		sub ebx, ecx					; ebx = Complment offset pour ligne suivante
		shr ecx, 2						; on transfert 16 bytes Dest  chaque boucle
		mov edi, [esp + 24]				; edi = Destination
		mov [esp + 32], ecx				; on stocke cette nouvelle valeur pour X
		jmp short Loop_Y

	ALIGN64

	Loop_Y
		push edi

		; D = E
		; E = F
		mov eax, [esi-2]
		mov [E], eax

		lea edi, [LineBuf]
	.Loop_X1

			; D = E
			; E = F
			mov eax, [E]
			mov [D], eax
	
			; B = (x, y-1)
			mov ax, [esi-336*2]
			mov [B], ax
			; H = (x, y+1)
			mov ax, [esi+336*2]
			mov [H], ax
			; F = (x+1, y)
			mov ax, [esi+2]
			mov [F], ax
			add esi, 2

			; AX <= F
			xor	edx, edx
			cmp [B], ax		; B==F ?
			jne	.BnF
			or dx, 1
		.BnF:
			shl	dx, 1
			cmp [H], ax		; H==F ?
			jne .HnF
			or dx, 1
		.HnF:
			shl dx, 1
			mov ax, [D]		; AX <= D
			cmp [B], ax		; B==D ?
			jne .DnB
			or dx, 1
		.DnB:
			shl dx, 1
			cmp [H], ax		; H==D ?
			jne .HnD
			or dx, 1
		.HnD:

			; E0 = D == B && B != F && D != H ? D : E;
			mov ax, dx
			and ax, 0Bh
			cmp ax, 02h
			jne	.eq0
			mov ax, [D]
			jmp .E0
		.eq0:
			mov ax, [E]
		.E0:
			mov [edi], ax

			; E1 = B == F && B != D && F != H ? F : E;
			mov ax, dx
			and ax, 0Eh
			cmp ax, 08h
			jne	.eq1
			mov ax, [F]
			jmp .E1
		.eq1:
			mov ax, [E]
		.E1:
			mov [edi+2], ax

			; E2 = D == H && D != B && H != F ? D : E;
			mov ax, dx
			and ax, 07h
			cmp ax, 01h
			jne	.eq2
			mov ax, [D]
			jmp .E2
		.eq2:
			mov ax, [E]
		.E2:
			mov [edi+640*2], ax

			; E3 = H == F && D != H && B != F ? F : E;
			mov ax, dx
			and ax, 0Dh
			cmp ax, 04h
			jne	.eq3
			mov ax, [F]
			jmp .E3
		.eq3:
			mov ax, [E]
		.E3:
			mov [edi+640*2+2], ax

			add	edi, 4

			dec ecx
			jnz .Loop_X1

	; Draw 2 lines on surface
		pop edi
		push esi
		lea esi, [LineBuf]
		mov ecx, [esp + 32]
		rep movsw
		pop esi

		mov ecx, [esp + 32]			; ecx = Nombre de pixels / 4 dans une ligne	
		add esi, [esp + 40]			; on augmente la source pour pointer sur la prochaine ligne
		dec dword [esp + 36]		; on continue tant qu'il reste des lignes
		jnz Loop_Y

		pop esi
		pop edi
		pop edx
		pop ecx
		pop ebx
		ret


;===================================================================
;=                               C++                               =
;===================================================================
; void Blit_Scale2x(unsigned char *Dest, int pitch, int x, int y, int offset)
; {
;  int i,j;

;  int B,D,E,F,H;
;  int E0,E1,E2,E3;

;  // A B C
;  // D E F
;  // G H I

;  int ScrWdth, ScrAdd;
;  int SrcOffs, DstOffs;

;  ScrAdd  = offset >> 1;
;  ScrWdth = x + ScrAdd;

;  SrcOffs = 8;
;  DstOffs = 0;

;  for (i=0; i<y; i++)
;  {
;   E = MD_Screen[SrcOffs-1];
;   F = MD_Screen[SrcOffs];

;   DstOffs = i*pitch*2;

;   for (j=0; j<x; j++)
;   {
;    D = E; E = F;
;    B = MD_Screen[SrcOffs-ScrWdth];
;    H = MD_Screen[SrcOffs+ScrWdth];
;    F = MD_Screen[++SrcOffs];

;    E0 = D == B && B != F && D != H ? D : E;
;    E1 = B == F && B != D && F != H ? F : E;
;    E2 = D == H && D != B && H != F ? D : E;
;    E3 = H == F && D != H && B != F ? F : E;

;    // E0
;    Dest[DstOffs]   = E0;
;    Dest[DstOffs+1] = E0>>8;
;    // E1
;    Dest[DstOffs+2] = E1;
;    Dest[DstOffs+3] = E1>>8;
;    // E2
;    Dest[DstOffs+pitch]   = E2;
;    Dest[DstOffs+pitch+1] = E2>>8;
;    // E3
;    Dest[DstOffs+pitch+2] = E3;
;    Dest[DstOffs+pitch+3] = E3>>8;

;    DstOffs += 4;
;   }
;   SrcOffs += ScrAdd;
;  }
; }